/*
 * Patternfiles.java
 *
 * Created on 22. Mai 2000, 13:30
 */


package YARB.FileSources.SNNS.PatternFiles;

import java.io.*;
import YARB.FileSources.SNNS.PatternFiles.Grammar;
import YARB.Interfaces.*;
/** 
 *
 * @author  Administrator
 * @version 
 */
public class Parser extends Grammar 
{

  /** Creates new Patternfiles */
  public Parser() {
  }
  
  public boolean FreeData() {    
    m_NoOfPattern=0;
    m_NoOfInput=0;
    m_NoOfOutput=0;
    m_NoOfVarIDim=0;
    m_NoOfVarODim=0;
    m_MaximumIDim = null;
    m_MaximumODim = null;
    m_InputPatternStreamLength=0;  m_InputStreamLength=0;
    m_OutputPatternStreamLength=0; m_OutputStreamLength=0;
    m_CurrentInputPattern=0; m_CurrentOutputPattern=0;
    m_CurrentPatternData=0;
    m_InputData=null; m_OutputData=null;
    return true;
  }
  
  public boolean Parse(String FileSource)  {
    BufferedReader InputSrc;    
    StringBuffer PatFileStr= new StringBuffer("");    
    int tmp;
    boolean state;
        
    try {     
      System.out.println("Reading "+FileSource);
      InputSrc = new BufferedReader( new FileReader(FileSource) );      
      while( (tmp = InputSrc.read()) != -1 ) {
        PatFileStr.append((char)tmp);
      }
      System.out.println("Validating "+FileSource);
      state = pattern_file(PatFileStr.toString());      
      InputSrc.close();
      if( state ) {
        System.out.println("Finished validating pattern file.");
        //ShowParam();
        return true;
      }
      System.out.println(FileSource + " isn't a valid pattern file!");
      FreeData();
      
    } catch (FileNotFoundException e1) {
        System.out.println("***FileNotFoundException: " + e1.toString() + "\n" + this.toString() );
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString()+ "\n" + this.toString());
    } catch (IOException e3) {
      System.out.println("***IOException: " + e3.toString()+ "\n" + this.toString());
    }
    return false;
  }
  
  public int No_OfPattern() {
    return m_NoOfPattern;
  }
  
  public int No_OfInput() {
    return m_InputPatternStreamLength;
  }
  
  public int No_OfOutput() {
    return m_OutputPatternStreamLength;
  }
  public int No_OfVarIDim() {
    return m_NoOfVarIDim;
  }
  public int No_OfVarODim() {
    return m_NoOfVarODim;
  }
  public int Maximum_IDim(int i) {
    if( m_NoOfVarIDim == 0 ) return 0;
    return m_MaximumIDim[i];
  }
  public int Maximum_ODim(int i) {
    if( m_NoOfVarODim == 0 ) return 0;
    return m_MaximumODim[i];
  }
  
  public float Input_Data(int pattern, int i) {
    if( pattern < 0 || pattern >= m_NoOfPattern || i > m_InputPatternStreamLength) {     
      System.out.println("Array bounds exceeded in InputData( " + pattern + ", " + i +") :" + "\n" + this.toString());      
      return 0;
    }
    return m_InputData[pattern][i];
  }
  
  public float Output_Data(int pattern, int i) {
    if( pattern < 0 || pattern >= m_NoOfPattern || i > m_OutputPatternStreamLength ) {
      System.out.println("Array bounds exceeded in OutputData( " + pattern + ", " + i + ") :" + "\n" + this.toString());      
      return 0;
    }
    return m_OutputData[pattern][i];
  }              

}