/*
 * YFSDummy.java
 *
 * Created on 17. April 2000, 22:19
 */

package YARB.FileSources;
import YARB.Interfaces.*;
import YARB.Dialogs.*;
import javax.swing.*;
import YARB.FileSources.SNNS.PatternFiles.Parser; 

/** 
 *
 * @author  Thomas
 * @version 
 */
public class YFSSNNSPatternFiles extends Object implements IFileSource 
{ 
  private Parser m_Pattern;
  private boolean m_PatternProcessed = false;  
  protected String m_FileName;  
   /**
  * Contains the assigned name string.
  */
  private String  m_strName;
  
  /** Creates new YFSDummy */
  public YFSSNNSPatternFiles() {
    m_Pattern = new Parser();    
  }
 
  /** This function forces the object to save its configuration data to a file
   */
  public boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError {
    if(Cfg==null) return false;
    
    Cfg.addTitle(getName());
    
    return true;
  }
  
  /** This function forces the object to read a configuration from a file
   */
  public boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError {
    if(Cfg==null) return false;
    
    setName(Cfg.getTitle());
    return true;
  }
  
  public boolean IsConfigurable()
  {
    return true;
  }
  
  
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
    YStandardNameChooser dlg= new YStandardNameChooser(ParentFrame, "YARB Viewer Properties",true,getName());
    dlg.show();
    
    setName(dlg.getName());
    return true;  
  }
  
  public int numbOfPatterns()
  {
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! numbOfPatterns " + this.toString());
      return 0;
    }    
    return m_Pattern.No_OfPattern();
  }
  
  public int numbOfInputUnits()
  {
     if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! numbOfInputUnits " + this.toString());
      return 0;
    }
    return m_Pattern.No_OfInput();
  }
  
  public int numbOfOutputUnits()
  { 
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! numOfOutputUnits " + this.toString());
      return 0;
    }
    return m_Pattern.No_OfOutput();
  }
  
  public int numbOfVariableInputDimensions()
  {
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! numbOfVariableInputDimensions " + this.toString());
      return 0;
    }    
    return m_Pattern.No_OfVarIDim();
  }
  
  public int numbOfVariableOutputDimensions()
  {
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! numbOfVariableOutputDimensions " + this.toString());
      return 0;
    }
    return m_Pattern.No_OfVarODim();
  }
  
  public int getMaxInputDimesion(int nVarInputDimension)
  {    
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! getMaxInputDimension " + this.toString());
      return 0;
    }
    return m_Pattern.Maximum_IDim(nVarInputDimension);
  }
  
  public int getMaxOutputDimesion(int nVarOutputDimension)
  {    
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! getMaxOutputDimensions " + this.toString());
      return 0;
    }
    return m_Pattern.Maximum_ODim(nVarOutputDimension);
  }
 
  public float getInputData(int nPattern,int nUnit)
  {
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! getInputData " + this.toString());
      return 0;
    }
    return m_Pattern.Input_Data(nPattern, nUnit);
  }
  
  public float getOutputData(int nPattern,int nUnit)
  { 
    if( !m_PatternProcessed ) {
      System.out.println("Pattern file was'nt yet parsed ! getOutputData " + this.toString());
      return 0;
    }
    return m_Pattern.Output_Data(nPattern, nUnit);
  }
  
  
  public boolean ProcessData()
  throws IDataProvider.DataProcessingError
  { boolean state;    
    state = m_Pattern.Parse(m_FileName);
    if( state ) m_PatternProcessed = true;
    else {
      throw new IDataProvider.DataProcessingError("Invalid pattern file <"+m_FileName+"> : " + this.toString());      
    }
    return state;
  }
  
  public boolean FreeData() {
    m_PatternProcessed = false;
    m_Pattern.FreeData();   
    return true;
  }
  
  public void setFileName(String strName)
  {
    m_FileName=strName;
  } 
  
  /**
  * Assigns a name to the current object.
  */
  public void setName(String strName){
    m_strName=strName;
  }
    
  /**
  * Returns the assigned name of the object
  */
  public String  getName(){
    return m_strName;
  }
 
}