/*
 * YDFWTA.java
 *
 * Created on 18. Mai 2000, 09:53
 */
 
package YARB.Filter;
import YARB.Interfaces.*;
import javax.swing.*;
import YARB.Filter.*;
import java.lang.Float;
/** 
 * YDFWTA - YARB Data Filter: The winner takes it all
 * This data filter processes all pattern and units and gives for every pattern the 
 * index number of the greatest unit. (numbers range from 0 to numbOfXXXUnits()-1)
 * @author  Thomas
 * @version 
 */
public class YDFArithmetic extends Object implements IDataFilter
{
  int        m_nOperand;
  int        m_nOperation;
  float      m_fConstValue;

  float      m_KonsInput;
  float      m_KonsOutput;
  float      m_InBuffer[][];
  float      m_OutBuffer[][];
  int        m_nNumbOfPattern;
  int        m_nNumbOfInUnits;
  int        m_nNumbOfOutUnits;
   
  int        m_VarInDimension;
  int        m_MaxVarInDim[];
  int        m_VarOutDimension;
  int        m_MaxVarOutDim[];
  
  IDataProvider m_DP;  // the previous provider

  /** Creates new YDFWTA */
  public YDFArithmetic() {
    m_DP=null;
    m_InBuffer=null;
    m_OutBuffer=null;
    m_MaxVarInDim=null;
    m_MaxVarOutDim=null;
    m_nNumbOfPattern=0;
    m_nNumbOfInUnits=0;
    m_nNumbOfOutUnits=0;
    m_VarInDimension=0;
    m_VarOutDimension=0;
    m_KonsInput=2;
    m_KonsOutput=2;
    m_nOperation=1;
    m_nOperand=1;
    m_fConstValue=0;
    
  }
  
  /** Sets the previour data provider.
   * This coudl be another data filter or a file source.
   */
  public void setPreviousProvider(IDataProvider DP) {
    m_DP=DP;
  }
  
  /** Starts the data processing task.
   */
  public boolean ProcessData() throws IDataProvider.DataProcessingError
  {
    if(m_DP==null) return false;

    //** Don't forget: You have to call the ProcessData method of your predecessor
    m_DP.ProcessData();
    
    // create the new Array of Pattern
    m_InBuffer= new float[m_DP.numbOfPatterns()][m_DP.numbOfInputUnits()];
    m_OutBuffer= new float[m_DP.numbOfPatterns()][m_DP.numbOfOutputUnits()];
    // Copy all Pattern
   // if(test = 1)getadd();
  if( getOperation() == 1)
    {
      for(int i =0; i < m_DP.numbOfPatterns(); i++)
      {
        if (getOperand() == 2){m_KonsInput=getmiddleInput(i);m_KonsOutput=getmiddleOutput(i);}
        else if (getOperand() == 3){m_KonsInput=getmaxInput(i);m_KonsOutput=getmaxOutput(i);}
        else if (getOperand() == 4){m_KonsInput=getminInput(i);m_KonsOutput=getminOutput(i);}
        else if (getOperand() == 5){m_KonsInput=getsumInput(i);m_KonsOutput=getsumOutput(i);}
        else if (getOperand() == 1){m_KonsInput=getConstVal();m_KonsOutput=getConstVal();};
        // Copy Input pattern
        for(int k=0; k< m_DP.numbOfInputUnits(); k++)
        {
           m_InBuffer[i][k]=m_DP.getInputData(i, k)+m_KonsInput;
        };
       
        // Copy Output Pattern
        for(int k=0; k< m_DP.numbOfOutputUnits(); k++)
        {
           m_OutBuffer[i][k]=m_DP.getOutputData(i, k)+m_KonsOutput;
        };
      };
    };
    if(  getOperation() == 2)
    {
      for(int i =0; i < m_DP.numbOfPatterns(); i++)
      {
         if (getOperand() == 2){m_KonsInput=getmiddleInput(i);m_KonsOutput=getmiddleOutput(i);}
        else if (getOperand() == 3){m_KonsInput=getmaxInput(i);m_KonsOutput=getmaxOutput(i);}
        else if (getOperand() == 4){m_KonsInput=getminInput(i);m_KonsOutput=getminOutput(i);}
        else if (getOperand() == 5){m_KonsInput=getsumInput(i);m_KonsOutput=getsumOutput(i);}
        else if (getOperand() == 1){m_KonsInput=getConstVal();m_KonsOutput=getConstVal();};
        // Copy Input pattern
        for(int k=0; k< m_DP.numbOfInputUnits(); k++)
        {
           m_InBuffer[i][k]=m_DP.getInputData(i, k)-m_KonsInput;
        };
       
        // Copy Output Pattern
        for(int k=0; k< m_DP.numbOfOutputUnits(); k++)
        {
           m_OutBuffer[i][k]=m_DP.getOutputData(i, k)-m_KonsOutput;
        };
      };
    }; 
    if(  getOperation() == 3)
    {
      for(int i =0; i < m_DP.numbOfPatterns(); i++)
      {
         if (getOperand() == 2){m_KonsInput=getmiddleInput(i);m_KonsOutput=getmiddleOutput(i);}
        else if (getOperand() == 3){m_KonsInput=getmaxInput(i);m_KonsOutput=getmaxOutput(i);}
        else if (getOperand() == 4){m_KonsInput=getminInput(i);m_KonsOutput=getminOutput(i);}
        else if (getOperand() == 5){m_KonsInput=getsumInput(i);m_KonsOutput=getsumOutput(i);}
        else if (getOperand() == 1){m_KonsInput=getConstVal();m_KonsOutput=getConstVal();};
        // Copy Input pattern
        for(int k=0; k< m_DP.numbOfInputUnits(); k++)
        {
           m_InBuffer[i][k]=m_DP.getInputData(i, k)*m_KonsInput;
        };
       
        // Copy Output Pattern
        for(int k=0; k< m_DP.numbOfOutputUnits(); k++)
        {
           m_OutBuffer[i][k]=m_DP.getOutputData(i, k)*m_KonsOutput;
        };
      };
    }; 
  if(  getOperation()==4)
    {
      for(int i =0; i < m_DP.numbOfPatterns(); i++)
      {
         if (getOperand() == 2){m_KonsInput=getmiddleInput(i);m_KonsOutput=getmiddleOutput(i);}
        else if (getOperand() == 3){m_KonsInput=getmaxInput(i);m_KonsOutput=getmaxOutput(i);}
        else if (getOperand() == 4){m_KonsInput=getminInput(i);m_KonsOutput=getminOutput(i);}
        else if (getOperand() == 5){m_KonsInput=getsumInput(i);m_KonsOutput=getsumOutput(i);}
        else if (getOperand() == 1){m_KonsInput=getConstVal();m_KonsOutput=getConstVal();};
        // Copy Input pattern
        if (m_KonsInput == 0|| m_KonsOutput == 0){
          System.out.println("ERROR: Division by null value in YDFArithmetic::ProcessData().");
          throw new IDataProvider.DataProcessingError("Division by null value in YDFArithmetic::ProcessData().");

        };
        for(int k=0; k< m_DP.numbOfInputUnits(); k++)
        {
           m_InBuffer[i][k]=m_DP.getInputData(i, k)/m_KonsInput;
        };
       
        // Copy Output Pattern
        for(int k=0; k< m_DP.numbOfOutputUnits(); k++)
        {
           m_OutBuffer[i][k]=m_DP.getOutputData(i, k)/m_KonsOutput;
        };
      };
    }; 
  if(  getOperation()==5)
    {
      for(int i =0; i < m_DP.numbOfPatterns(); i++)
      {
        if (getOperand() == 2){m_KonsInput=getmiddleInput(i);m_KonsOutput=getmiddleOutput(i);}
        else if (getOperand() == 3){m_KonsInput=getmaxInput(i);m_KonsOutput=getmaxOutput(i);}
        else if (getOperand() == 4){m_KonsInput=getminInput(i);m_KonsOutput=getminOutput(i);}
        else if (getOperand() == 5){m_KonsInput=getsumInput(i);m_KonsOutput=getsumOutput(i);}
        else if (getOperand() == 1){m_KonsInput=getConstVal();m_KonsOutput=getConstVal();};
        // Copy Input pattern
        for(int k=0; k< m_DP.numbOfInputUnits(); k++)
        {
          m_InBuffer[i][k]=1;
          for(int j=0; j<m_KonsInput; j++)
          {
            m_InBuffer[i][k]=m_InBuffer[i][k]*m_DP.getInputData(i,k);
          };  
        };
       
        // Copy Output Pattern
        for(int k=0; k< m_DP.numbOfOutputUnits(); k++)
        {
          m_OutBuffer[i][k]=1; 
          for(int j=0; j<m_KonsOutput; j++)
          {
            m_OutBuffer[i][k]=m_OutBuffer[i][k]*m_DP.getOutputData(i,k);
          };
        };
      };
    }; 

   // Copy state information:
  
    m_nNumbOfPattern=m_DP.numbOfPatterns();
    m_nNumbOfInUnits=m_DP.numbOfInputUnits();
    m_nNumbOfOutUnits=m_DP.numbOfOutputUnits();
    m_VarInDimension= m_DP.numbOfVariableInputDimensions();
    m_VarOutDimension= m_DP.numbOfVariableOutputDimensions();

    if(m_VarInDimension>0)
    {
        m_MaxVarInDim= new int[m_VarInDimension];
        for(int j=0; j<m_VarInDimension;j++)
        {
          m_MaxVarInDim[j]=m_DP.getMaxInputDimesion(j);
        };
    };
      
    if(m_VarOutDimension>0)
    {
        m_MaxVarOutDim= new int[m_VarOutDimension];
        for(int j=0; j<m_VarOutDimension;j++)
        {
          m_MaxVarOutDim[j]=m_DP.getMaxOutputDimesion(j);
        };
    };
    
    
    
    //** Data processing finished.
    
    //** Don't forget: Call the FreeData method of your predecessor!
    m_DP.FreeData();
    
    
    // Everything O.K.
    return true;
    
  }
  
  public int getOperation(){
    return m_nOperation;
  }
  
  
  public int getOperand(){
    return m_nOperand;
  }
  
   public float getConstVal(){
    return m_fConstValue;
  }
  
  
  private float getmiddleInput(int i)
  {
    float f=0;
    float m=0;
    for(int j=0; j < m_DP.numbOfInputUnits(); j++)
    {
      f = m_DP.getInputData(i,j);
      m = m+f;
    };
    m = m/m_DP.numbOfInputUnits();
    return m;
  }

private float getmiddleOutput(int i)
  {
    float f=0;
    float m=0;
    for(int j=0; j < m_DP.numbOfOutputUnits(); j++)
    {
      f = m_DP.getOutputData(i,j);
      m = m+f;
    };
    m = m/m_DP.numbOfOutputUnits();
    return m;
  }  
  
  
  private float getsumInput(int i)
  {
    float f=0;
    float m=0;
    for(int j=0; j < m_DP.numbOfInputUnits(); j++)
    {
      f = m_DP.getInputData(i,j);
      m = m+f;
    };
    //m = m/m_DP.numbOfInputUnits();
    return m;
  }
  private float getsumOutput(int i)
  {
    float f=0;
    float m=0;
    for(int j=0; j < m_DP.numbOfOutputUnits(); j++)
    {
      f = m_DP.getOutputData(i,j);
      m = m+f;
    };
    //m = m/m_DP.numbOfOutputUnits();
    return m;
  } 
   
  private float getmaxInput(int i)
  {
    float f=0;
    float m=Float.MIN_VALUE;
    for(int j=0; j < m_DP.numbOfInputUnits(); j++)
    {
      f = m_DP.getInputData(i,j);
      if (f > m)m=f;
    };
    return m;
  }

  private float getmaxOutput(int i)
  {
    float f=0;
    float m=Float.MIN_VALUE;
    for(int j=0; j < m_DP.numbOfOutputUnits(); j++)
    {
      f = m_DP.getOutputData(i,j);
      if (f > m)m=f;
    };
    return m;
  }
  private float getminInput(int i)
  {
    float f=0;
    float m=Float.MAX_VALUE;
    for(int j=0; j < m_DP.numbOfInputUnits(); j++)
    {
      f = m_DP.getInputData(i,j);
      if (f < m)m=f;
    };
    return m;
  }

  private float getminOutput(int i)
  {
    float f=0;
    float m=Float.MAX_VALUE;
    for(int j=0; j < m_DP.numbOfOutputUnits(); j++)
    {
      f = m_DP.getOutputData(i,j);
      if (f < m)m=f;
    };
    m = m/m_DP.numbOfOutputUnits();
    return m;
  }
  
  
  
  
  /** Frees the internal buffers
   */
  public boolean FreeData() 
  {
    if(m_DP==null) return false;

    m_InBuffer=null;
    m_OutBuffer=null;
    m_MaxVarInDim=null;
    m_MaxVarOutDim=null;
    m_nNumbOfPattern=0;
    m_nNumbOfInUnits=0;
    m_nNumbOfOutUnits=0;
    m_VarInDimension=0;
    m_VarOutDimension=0;
    
    return true;
  }
  
  /** This function forces the object to save its configuration data to a file
   */
  public boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError {
    if(Cfg==null) return false;
    
    Cfg.addTitle(getName());
    Cfg.addInt(m_nOperand);
    Cfg.addInt(m_nOperation);
    Cfg.addfloat(m_fConstValue);

    return true;
  }
  
  /** This function forces the object to read a configuration from a file
   */
  public boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError {
    if(Cfg==null) return false;
    
    setName(Cfg.getTitle());
    m_nOperand=Cfg.getInt();
    m_nOperation=Cfg.getInt();
    m_fConstValue=Cfg.getfloat();
    
    return true;
  }  
  /** Can the object be configured by the user
   */
  public boolean IsConfigurable() {
    return true;
  }
  
  /** Shows the configuration dialog provided by the object
   */
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
   YDFArithmeticCFG dlg;
    dlg = new YDFArithmeticCFG(ParentFrame,"YARB Arithmetic Filter Properties",true);
    dlg.setOperation(getOperation());
    dlg.setOperand(getOperand());
    dlg.setConstVal(getConstVal());
    
    dlg.show();
    
    m_nOperand=dlg.getOperand();
    m_nOperation=dlg.getOperation();
    m_fConstValue=dlg.getConstVal();
    
    
    return true;  
  }
  

  /**
  * Contains the assigned name string.
  */
//  private int m_test3;
  
  //public void getint() {
    //return m_test3;
  //}
  
  private String  m_strName;
  
   /** Sets the Name of the object
   * This is a user-defined name. Has nothig to do with the toName-Function
   */
  public void setName(String strName) {
    m_strName=strName;
  }
 
  /** Gets the user defined name of the object.
   * This is a user-defined name. Has nothig to do with the toName-Function
   */
  public String getName() {
    return m_strName;
  }
  
  /** Gets the number of pattern.
   */
  public int numbOfPatterns() {
    return m_nNumbOfPattern;
  }
  
  /** Gets the number of input units.
   */
  public int numbOfInputUnits() {
    return m_nNumbOfInUnits;
  }
  
  /** Gets the number of Output Units
   */
  public int numbOfOutputUnits() {
    return m_nNumbOfOutUnits;
  }
  
  /** Gets the number of variable Input dimensions
   */
  public int numbOfVariableInputDimensions() {
    return m_VarInDimension;
  }
  
  /** Gets the number of variable Output dimensions
   */
  public int numbOfVariableOutputDimensions() {
    return m_VarOutDimension;
  }
 
  /** Gets the maximum input dimensions range for the given variable input dimension
  */
  public int getMaxInputDimesion(int nVarInputDimension) 
  {
    // Check array bounds:
    if(nVarInputDimension>=m_VarInDimension || nVarInputDimension < 0)
    {
      String msg="ERROR: Array bound exceeded! (Object: " + this.toString() + "; Method: getMaxInputDimension(int); Index: " + nVarInputDimension + "; Max: " + m_VarInDimension + ";)";
      System.out.println(msg);
      return 0;
    };
    // Everything O.K.
    return m_MaxVarInDim[nVarInputDimension];
  }
  
  /** Gets the maximum output dimensions range for the given variable output dimension
   */
  public int getMaxOutputDimesion(int nVarOutputDimension)
  {
    // Check array bounds:
    if(nVarOutputDimension>=m_VarOutDimension || nVarOutputDimension < 0)
    {
      String msg="ERROR: Array bound exceeded! (Object: " + this.toString() + "; Method: getMaxOutputDimension(int); Index: " + nVarOutputDimension + "; Max: " + m_VarOutDimension + ";)";
      System.out.println(msg);
      return 0;
    };
    // Everything O.K.
    return m_MaxVarOutDim[nVarOutputDimension];
  }
  
  /** Gets a input data field, inthe given pattern and specified by the give unit.
   */
  public float getInputData(int nPattern,int nUnit) 
  {
    // Check array Bounds:
    if(nPattern>=m_nNumbOfPattern || nPattern < 0)
    {
      String msg="ERROR: Array bound exceeded! (Object: " + this.toString() + "; Method: getInputData(int,int); Index: " + nPattern + "; Max: " + m_nNumbOfPattern + ";)";
      System.out.println(msg);
      return 0;
    };
    if(nUnit>=m_nNumbOfInUnits || nUnit < 0)
    {
      String msg="ERROR: Array bound exceeded! (Object: " + this.toString() + "; Method: getInputData(int,int); Index: " + nUnit + "; Max: " + m_nNumbOfInUnits + ";)";
      System.out.println(msg);
      return 0;
    };
    // Bounds OK, return value
    return m_InBuffer[nPattern][nUnit];
  }
  
  
  /** Gets a output data field, inthe given pattern and specified by the give unit.
   */
  public float getOutputData(int nPattern,int nUnit) 
  {
    // Check array Bounds:
    if(nPattern>=m_nNumbOfPattern || nPattern < 0)
    {
      String msg="ERROR: Array bound exceeded! (Object: " + this.toString() + "; Method: getOutputData(int,int); Index: " + nPattern + "; Max: " + m_nNumbOfPattern + ";)";
      System.out.println(msg);
      return 0;
    };
    if(nUnit>=m_nNumbOfOutUnits || nUnit < 0)
    {
      String msg="ERROR: Array bound exceeded! (Object: " + this.toString() + "; Method: getOutputData(int,int); Index: " + nUnit + "; Max: " + m_nNumbOfOutUnits + ";)";
      System.out.println(msg);
      return 0;
    };
    // Bounds OK, return value
    return m_OutBuffer[nPattern][nUnit];
  }
}