/*
 * YDVAgent.java
 *
 * Created on 05. June 2000, 20:04
 */
 
package YARB.Viewer.SpecialViewer;
import YARB.Interfaces.*;
import YARB.Main.YDefaultDataHolder;
import YARB.Dialogs.*;
import javax.swing.*;
import java.io.File;

/** 
 *
 * @author  Erich
 * @version 
 */
public class YDVAgent extends Object implements IDataViewer
{
  
  private String m_Caption;
  private String m_File;
  private IDataProvider m_DP;
  private String m_strX;        // Member variables for X-Axes title
  private String m_strY;        // 
  private String m_title;       // Membervariable for the Title of the Viewer
  private String m_ratio;
  
  /** Creates new YDVAgent */
  public YDVAgent() {
    m_DP=null;
    m_Caption="";
    m_File="";
    m_strX="x Axis";                 
    m_strY="y Axis";                
    m_title="File: [FILENAME] ([PATH])";
    m_ratio="1";
  }
  
  public void setCaption(String strTitle) {
    m_Caption=strTitle;
  }
  public void setDataSource(IDataProvider DP) {
    m_DP=DP;
  }
  public void setFileName(String Name) {
    m_File=Name;
    StringBuffer str= new StringBuffer(m_title);
    File fn = new File(m_File);
    int i=str.toString().indexOf("[FILENAME]");
    if(i>=0) 
    {
      str.replace(i,i+"[FILENAME]".length(),fn.getName());
    };
    i=str.toString().indexOf("[PATH]");
    if(i>=0) 
    {
      str.replace(i,i+"[PATH]".length(),fn.getParent());
    };
    
    m_title=str.toString();

  }
  public boolean DoVisualize(IMainFrame ParentFrame) throws IDataProvider.DataProcessingError {
    
    if(m_DP==null){
      return false;
    };
    
    YDefaultDataHolder data=new YDefaultDataHolder();
    
    m_DP.ProcessData();
    data.setData(m_DP);
    m_DP.FreeData();
    
    String str= m_Caption + " (" + m_File + ")" + " [" + m_strName + "]";
    YDVAgentFrame txt = new YDVAgentFrame(str,m_strX,m_strY,m_title);
    txt.setDataHolder(data);
    txt.setLocation(ParentFrame.GetNextCreationPoint());
    ParentFrame.AddFrame(txt);
    
    return true;
  }
  /** This function forces the object to save its configuration data to a file
   */
  public boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError {
    if(Cfg==null) return false;
    
    Cfg.addTitle(getName());
    Cfg.addString(m_strX);     
    Cfg.addString(m_strY);
    Cfg.addString(m_title);
    Cfg.addString(m_ratio);
    
    return true;
  }
  
  /** This function forces the object to read a configuration from a file
   */
  public boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError {
    if(Cfg==null) return false;
    
    setName(Cfg.getTitle());
    m_strX=Cfg.getString();   
    m_strY=Cfg.getString();
    m_title=Cfg.getString();
    m_ratio=Cfg.getString();
    return true;
  }  
   
  public boolean IsConfigurable() {
    return true;
  }
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
   
    YAgentViewerCFG dlg= new YAgentViewerCFG(ParentFrame, "YARB Agent Viewer Properties",true);
    dlg.setName(getName());
    dlg.setXAxisTitle(m_strX);
    dlg.setYAxisTitle(m_strY);
    dlg.setViewerTitle(m_title);
    dlg.setRatio(m_ratio);
    dlg.show();
    
   
    setName(dlg.getName());
    m_strX=dlg.getXAxisTitle();
    m_strY=dlg.getYAxisTitle();
    m_title=dlg.getViewerTitle();
    m_ratio=dlg.getRatio();
    return true;  
  }
  
  /**
  * Contains the assigned name string.
  */
  private String  m_strName;
  
  /**
  * Assigns a name to the current object.
  */
  public void setName(String strName){
    m_strName=strName;
  }
    
  /**
  * Returns the assigned name of the object
  */
  public String  getName(){
    return m_strName;
  }
  
}