/*
 * YDVAgentFrame.java
 *
 * Created on 17. Mai 2000, 20:04
 */
package YARB.Viewer.SpecialViewer;
import YARB.Interfaces.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.Graphics2D;
import javax.swing.ImageIcon;

/**
 *
 * @author  Erich
 * @version
 */
public class YDVAgentFrame extends javax.swing.JInternalFrame {

  private IDataHolder m_data;         // Holds the data
  private int m_nCurrentPattern;      // The number of the currently selected pattern
  private boolean m_bCurrentIsInput;  // Is the currently selected pattern an input pattern?
 
  ImageIcon m_Left,m_Right,m_Up,m_Down;
  
  private String m_strX;              
  private String m_strY;              
  private String m_title;
  
  public YDVAgentFrame(String strTitle,String strX, String strY,String ViewerTitle ){
    super(strTitle,
    true, //resizable
    true, //closable
    true, //maximizable
    true

    );//iconifiable


    initComponents();
    setSize(500,500);
    
    m_Left  = new ImageIcon(getClass().getResource("/YARB/images/AgentExample/Left.gif"));
    m_Right = new ImageIcon(getClass().getResource("/YARB/images/AgentExample/Right.gif"));
    m_Up    = new ImageIcon(getClass().getResource("/YARB/images/AgentExample/Up.gif"));
    m_Down  = new ImageIcon(getClass().getResource("/YARB/images/AgentExample/Down.gif"));
  
    m_data=null;
    m_strX=strX;        
    m_strY=strY;        
    m_title = ViewerTitle;
  }

  
  
  private void initComponents () {//GEN-BEGIN:initComponents
    scrollPane = new javax.swing.JScrollPane ();
    pane = new javax.swing.JPanel ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());
    setDoubleBuffered (true);
    setBackground (java.awt.Color.white);
    setDebugGraphicsOptions (javax.swing.DebugGraphics.NONE_OPTION);
    setForeground (java.awt.Color.white);

    scrollPane.setDoubleBuffered (true);
    scrollPane.setOpaque (true);
    scrollPane.setBackground (java.awt.Color.white);
    scrollPane.setDebugGraphicsOptions (javax.swing.DebugGraphics.NONE_OPTION);

  
      scrollPane.setViewportView (pane);
  

    getContentPane ().add (scrollPane, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JScrollPane scrollPane;
  private javax.swing.JPanel pane;
  // End of variables declaration//GEN-END:variables
 
  public void setDataHolder(IDataHolder data){
    m_data=data;
  }


  
public void paint(Graphics g)
  {
      super.paint(g);
      Graphics2D g2 = (Graphics2D) g;
      Dimension d = getSize();
      
      g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    
      if(m_data==null) return;  // uups. no data? fuck!
      
      Color black = Color.black;
   
  
      float fAxisSetX,fAxisSetY;
      int count=0;
      // Are there negative Values ? ....   
      for(int i=0; i < m_data.numbOfPatterns(); i++) { 
        fAxisSetX = m_data.getInputData(i,0); 
          if (fAxisSetX < 0) count=1;
        fAxisSetY = m_data.getInputData(i,1);
          if (fAxisSetY < 0) count=1;
      }
   
      
      int XAxis   =  40,  
          YAxis   =  d.height -40,   
          StartX = 40,
          StartY = 90,
          EndX = d.width -40,
          EndY = d.height -35;
      
      // Axis are changed if negative values have been found.
      if (count > 0) {
              XAxis   =  d.width /2;   
              YAxis   =  d.height /2+30; 
              StartX = 40;
              StartY = 90;
              EndX = d.width -40;
              EndY = d.height -30;
          }
   
          
      if(m_data.numbOfInputUnits() < 2) {
        System.out.println("Number of Inputunits too small: Minimum 2!");
        return;
      }
      if(m_data.numbOfOutputUnits() < 1) {
        System.out.println("Number of Outputunits too small: Minimum 1!");
        return;
      }
  
      g2.setPaint(black);  
        
      Font bigFont = new Font("Arial", Font.ITALIC, 25);
      Font smallFont = new Font("Arial", Font.PLAIN, 10);
      
      g2.setFont(bigFont);
      FontMetrics bFont = g2.getFontMetrics();
      int widthTitle = bFont.stringWidth( m_title );
      g2.drawString( m_title, 30, 60 );
      
     
      g2.setFont(smallFont);
      FontMetrics sFont = g2.getFontMetrics();
      int widthX = sFont.stringWidth( m_strX ),
          widthY = sFont.stringWidth( m_strY );
        
      
      // Axis labelling specially for neg axis
      if (count > 0) {g2.drawString(m_strY, XAxis - widthY/2, StartY-15);}
        else g2.drawString(m_strY, 10, StartY-15);
      g2.drawString(m_strX, d.width-widthX -15,YAxis+ 25);

      
      
    g2.drawLine(StartX, YAxis, EndX, YAxis);        // Axes
    g2.drawLine(XAxis, StartY , XAxis, EndY);
   
    g2.drawLine( EndX, YAxis,  EndX-8, YAxis-5);  // Axes-Arrows
    g2.drawLine( EndX, YAxis,  EndX-8, YAxis+5);
    
    g2.drawLine( XAxis, StartY,  XAxis-5, StartY+8);
    g2.drawLine( XAxis, StartY,  XAxis+5, StartY+8);
   
  
      
      
    int deltay = (int)((YAxis - StartY -20)/10);
    int deltax = (int)((EndX-XAxis -20)/10);
    int tempx=0,tempy=0;

   
    
    for(int i=1; i < 11 ; i++)
     {
       g2.drawLine(XAxis-4, YAxis-(i*deltay) ,XAxis+4, YAxis-(i*deltay) );
       g2.drawLine(XAxis+(i*deltax), YAxis-4 ,XAxis+(i*deltax), YAxis+4 );
        if (i==10) { tempy = YAxis-(i*deltay);
                     tempx = XAxis-(i*deltax);
                 }
   
     };
     //negativ axis scaling, only if neg val. are found
     if (count > 0){
      for(int i=1; i < 11 ; i++)
       {
         g2.drawLine(XAxis-4, YAxis+(i*deltay) ,XAxis+4, YAxis+(i*deltay) );
         g2.drawLine(XAxis-(i*deltax), YAxis-4 ,XAxis-(i*deltax), YAxis+4 );
       };
    }
   
    
// drawing the input output values
      
      float MaximumX=0;
      float MaximumY=0;
      float NegMaxX=0;
      float NegMaxY=0;
      int PercentageX = XAxis - tempx;
      int PercentageY = YAxis - tempy;
      int x,y;
      
      
      for(int i=0; i < m_data.numbOfPatterns(); i++){
         int xaval = (int) (m_data.getInputData(i,0)*10);
         int yaval = (int) (m_data.getInputData(i,1)*10);
        
         //g2.drawString(""+yaval, XAxis+10, YAxis-(yaval*deltay)+5);
         //g2.drawString(""+xaval, XAxis+(xaval*deltax)-5, YAxis + 15);       
              
              
       
          if  (Math.abs(m_data.getInputData(i,0)) >= MaximumX)
            { MaximumX = Math.abs(m_data.getInputData(i,0));}
          if  (m_data.getInputData(i,0) <= NegMaxX)
            { NegMaxX = m_data.getInputData(i,0);}
          
          if  (Math.abs(m_data.getInputData(i,1)) >= MaximumY)
            { MaximumY = Math.abs(m_data.getInputData(i,1));}  
          if  (m_data.getInputData(i,1) <= NegMaxY)
            { NegMaxY = m_data.getInputData(i,1);}     
              
      };
         
         g2.drawString(""+MaximumX, XAxis+10, YAxis-(10*deltay)+5);
         g2.drawString(""+MaximumY, XAxis+(10*deltax)-5, YAxis + 15);   
         g2.drawString(""+NegMaxX, XAxis+10, YAxis+(10*deltay)+5);
         g2.drawString(""+NegMaxY, XAxis-(10*deltax)-5, YAxis + 15);   

     

     float pic;
     
     for(int i=0; i < m_data.numbOfPatterns(); i++){
     
        x = (int) (m_data.getInputData(i,0)*PercentageX / MaximumX);
        y = (int) (m_data.getInputData(i,1)*PercentageY / MaximumY);
        
        int xval = XAxis+x -4, 
            yval = YAxis-y -4;
        
        pic = m_data.getOutputData(i,0); 
        if ( pic > -0.5 && pic < 0.5)
         {
          m_Left.paintIcon(pane,g,xval, yval);
         }
        else if ( pic > 0.5 && pic < 1.5)
         {
          m_Up.paintIcon(pane,g,xval, yval);
         }
        else if ( pic > 1.5 && pic < 2.5)
         {
          m_Right.paintIcon(pane,g,xval, yval);
         }
        else if ( pic > 2.5 && pic < 3.5)
         {
           m_Down.paintIcon(pane,g,xval, yval);
         }
    
       };     
 
    }

}
