package YARB.Viewer.StdViewer;/*
 * YDVLineChart.java
 *
 * Created on 18. May 2000, 22:04
 */
 

import YARB.Interfaces.*;
import YARB.Main.YDefaultDataHolder;
import YARB.Dialogs.*;
import javax.swing.*;

/** 
 *
 * @author  Erich
 * @version 
 */
public class YDVLineChart extends Object implements IDataViewer
{
  
  private String m_Caption;
  private String m_File;
  private IDataProvider m_DP;
  private String m_strX;       
  private String m_strY;      

  /** Creates new YDVLineChart */
  public YDVLineChart() {
    m_DP=null;
    m_Caption="";
    m_File="";
    m_strX="(User Comment)";                
    m_strY="(User Comment)";                
  }
  
  public void setCaption(String strTitle) {
    m_Caption=strTitle;
  }
  public void setDataSource(IDataProvider DP) {
    m_DP=DP;
  }
  public void setFileName(String Name) {
    m_File=Name;
  }
  public boolean DoVisualize(IMainFrame ParentFrame) throws IDataProvider.DataProcessingError {
    
    if(m_DP==null){
      return false;
    };
    
    YDefaultDataHolder data=new YDefaultDataHolder();
    
    m_DP.ProcessData();
    data.setData(m_DP);
    m_DP.FreeData();
    
    String str= m_Caption + " (" + m_File + ")" + " [" + m_strName + "]";
    YDVLineChartFrame txt = new YDVLineChartFrame(str,m_strX,m_strY);       
    txt.setDataHolder(data);
    txt.setLocation(ParentFrame.GetNextCreationPoint());
    ParentFrame.AddFrame(txt);
  
    return true;
  }
  /** This function forces the object to save its configuration data to a file
   */
  public boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError {
    if(Cfg==null) return false;
    
    Cfg.addTitle(getName());
    Cfg.addString(m_strX);      
    Cfg.addString(m_strY);      
    
    return true;
  }
  
  /** This function forces the object to read a configuration from a file
   */
  public boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError {
    if(Cfg==null) return false;
    
    setName(Cfg.getTitle());
    m_strX=Cfg.getString();   
    m_strY=Cfg.getString();   
    
    return true;
  }  
 
  public boolean IsConfigurable() {
    return true;
  }
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
    
    YStandardViewerCFG dlg= new YStandardViewerCFG(ParentFrame, "YARB Viewer Properties",true);
    dlg.setName(getName());
    dlg.setXAxisTitle(m_strX);
    dlg.setYAxisTitle(m_strY);
    dlg.show();
    
    
    setName(dlg.getName());
    m_strX=dlg.getXAxisTitle();
    m_strY=dlg.getYAxisTitle();
    return true;  
  }
  
  /**
  * Contains the assigned name string.
  */
  private String  m_strName;
  
  /**
  * Assigns a name to the current object.
  */
  public void setName(String strName){
    m_strName=strName;
  }
    
  /**
  * Returns the assigned name of the object
  */
  public String  getName(){
    return m_strName;
  }
  
}