package YARB.Viewer.StdViewer;/*
 * YDVLineChartFrame.java
 *
 * Created on 1. Mai 2000, 15:28
 */
 

import YARB.Interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.Vector;


/** 
 *
 * @author  Erich
 * @version 
 */
public class YDVLineChartFrame extends javax.swing.JInternalFrame {



  private IDataHolder m_data;         // Holds the data
  private int m_nCurrentPattern;      // The number of the currently selected pattern
  private boolean m_bCurrentIsInput;  // Is the currently selected pattern an input pattern?
  private Vector  m_vListData;        // Holds the List data
  private String m_strX;              // Holds the Axistitle
  private String m_strY;              
  

  public YDVLineChartFrame(String strTitle,String strX,String strY){ 
    super(strTitle,
                true, //resizable
                true, //closable
                true, //maximizable
                true);//iconifiable
    
    
    initComponents();
    setSize(500,500);
    splitPane.setDividerLocation(120);

    m_data=null;
    m_nCurrentPattern=0;
    m_bCurrentIsInput=true;
    m_vListData=null;
    m_strX  =strX;          
    m_strY = strY;          
  }
 

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    splitPane = new javax.swing.JSplitPane ();
    patternPane = new javax.swing.JScrollPane ();
    jScrollPane1 = new javax.swing.JScrollPane ();
    patternList = new javax.swing.JList ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());

    splitPane.setDoubleBuffered (true);
    splitPane.setBackground (java.awt.Color.white);
    splitPane.setOneTouchExpandable (true);

      patternPane.setDoubleBuffered (true);
      patternPane.setOpaque (true);
      patternPane.setBackground (java.awt.Color.white);
  
      splitPane.setRightComponent (patternPane);
  
      jScrollPane1.setDoubleBuffered (true);
      jScrollPane1.setOpaque (true);
  
        patternList.setDoubleBuffered (true);
        patternList.addListSelectionListener (new javax.swing.event.ListSelectionListener () {
          public void valueChanged (javax.swing.event.ListSelectionEvent evt) {
            patternListValueChanged (evt);
          }
        }
        );
    
        jScrollPane1.setViewportView (patternList);
    
      splitPane.setLeftComponent (jScrollPane1);
  

    getContentPane ().add (splitPane, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  
  private void patternListValueChanged (javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_patternListValueChanged
// Add your handling code here:
        if (evt.getValueIsAdjusting())
            return;

        JList theList = (JList)evt.getSource();
        if (theList.isSelectionEmpty()) {
            m_nCurrentPattern=0;
            m_bCurrentIsInput=true;
        } else {
            int index = theList.getSelectedIndex();
            if(m_vListData==null) return;
            
            ListElement e= (ListElement)m_vListData.get(index);
            m_nCurrentPattern=e.getPattern();
            m_bCurrentIsInput=e.isInput();
        }    
        
        // Call the java-swion repaint method (NOT my Repaint!)
        
        repaint();
        
  }//GEN-LAST:event_patternListValueChanged


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSplitPane splitPane;
  private javax.swing.JScrollPane patternPane;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JList patternList;
  // End of variables declaration//GEN-END:variables

  public void setDataHolder(IDataHolder data){
    m_data=data;
    Repaint();
  }

  /** Repaints the frame cause the data has changed
  *   NOTE: This method is user-defined and has nothing
  *   to do with the Java-Swing "repaint"-method!!!
  */  
  public void Repaint()
  {
    if(m_data==null) return;  // uups. no data? fuck!

    // Do your On-Data-Change things.

    //** Create the pattern List:
    m_vListData= new Vector();
    
    for(int i=0; i<m_data.numbOfPatterns();i++)
    {
      if (m_data.numbOfInputUnits()>0){
        m_vListData.add(new ListElement(i,true,">> Input pattern " + i));
      };
      if (m_data.numbOfOutputUnits()>0){
        m_vListData.add(new ListElement(i,false,"<< Output pattern " + i));
      };
    };
    // Set the new pattern list:
    patternList.setListData(m_vListData);
  }
  
  /** 
  *  This function gives the number of the curently selected pattern in the pattern list
  */
  public int getCurrentPattern(){
    return m_nCurrentPattern;
  }
  
  /**
  * This function says whether the currently selected pattern in the pattern list is an input pattern.
  * Returns true if it is an input pattern or false if it is a output pattern.
  */
  public boolean getCurrentIsInput(){
    return m_bCurrentIsInput;
  }

  /**
  * Returns the paint area's upper left corner.
  */
  private Point getUpperLeftPaintCorner(){
    return new Point(splitPane.getDividerLocation()+splitPane.getDividerSize(),getInsets().top*3);
  }
    
  
  /** Overloading of the Java-Swing paint method for user drawn graphics.
  *   Here the 2D graphics will be painted.
  *   This function is called by the java framework every time when the
  *   frame has to be repainted.
  */
 

  /**
  *  ListElement is a container class of information for each list element.
  */
  private class ListElement extends Object
  {
    private int m_nPattern;
    private boolean m_bInput;
    private String m_strTitle;
    
    ListElement(int nPattern,boolean bInput, String strTitle)
    {
      m_nPattern=nPattern;
      m_bInput=bInput;
      m_strTitle=strTitle;
    }
    
      public String toString() {
      return m_strTitle;
    }
    
    int getPattern(){
      return m_nPattern;
    }
    
    boolean isInput(){
      return m_bInput;
    }
  }

  
  
  /** This method is used to visualize the data
  *   on the screen
  */
  
  public void paint(Graphics g)
  {
    // NOTE: Don't forget to let the frame painted by your base class first!
    super.paint(g);   

    Graphics2D g2 = (Graphics2D) g;
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    Dimension d = getSize();
   
    Point start=getUpperLeftPaintCorner();
    int LBorder   = start.x + 50;   // Leftborder
    int RBorder   = d.width - 30;   // RightBorder
    int TBorder   = start.y + 50;   // TopBorder
    int BBorder   = d.height - 80;  // BottomBorder
    float fAxesSet;     // Negativ /positiv axesrange         
    Color red = Color.red;
    Color green = Color.green;
    Color black = Color.black;
    
    if(m_data==null) return;  // uups. no data? fuck!

    
// *******************************************************************************
// evaluate axes for positive und positive/negative Values    
// *******************************************************************************
    if(getCurrentIsInput())   // Is an input pattern selected?
    {     
      for(int i=0; i < m_data.numbOfInputUnits(); i++) { 
        fAxesSet = m_data.getInputData(getCurrentPattern(),i); 
        if (fAxesSet < 0) BBorder = d.height /2;
      }
    }
    else
    {
      for(int i=0; i < m_data.numbOfOutputUnits(); i++) { 
        fAxesSet = m_data.getOutputData(getCurrentPattern(),i); 
        if (fAxesSet < 0) BBorder = d.height /2;
      }
    }  
    
    
  
    g2.drawLine(LBorder, BBorder, RBorder, BBorder);        // Axes
    g2.drawLine(LBorder, d.height - 80 , LBorder, TBorder);
   
    g2.drawLine( RBorder, BBorder,  RBorder-8, BBorder-5);  // Axes-Arrows
    g2.drawLine( RBorder, BBorder,  RBorder-8, BBorder+5);
    
    g2.drawLine( LBorder, TBorder,  LBorder-5, TBorder+8);
    g2.drawLine( LBorder, TBorder,  LBorder+5, TBorder+8);
    
    g2.drawString("Result [%]", LBorder-20, TBorder-16);
    g2.drawString(m_strY, LBorder-30, TBorder-3);

  
    
    // Axes ...
  
    int deltay = (int)((BBorder - TBorder-50)/10);
    int temp=0;

    for(int i=1; i < 11 ; i++)
     {
       g2.drawLine(LBorder-2, BBorder-(i*deltay) ,LBorder+2,BBorder-(i*deltay) );
      
      if (i==5)  { g2.drawString("50",LBorder-30, BBorder-(i*deltay)+5);}
      if (i==10) { g2.drawString("100",LBorder-30, BBorder-(i*deltay)+5); 
                   temp = BBorder-(i*deltay);
                   
                 }
     };
    // negativ axis value drawing
    if (BBorder == d.height/2){
      for(int i=1; i < 11 ; i++)
      {
         g2.drawLine(LBorder-2, BBorder+(i*deltay) ,LBorder+2,BBorder+(i*deltay) );
      
        if (i==5)  { g2.drawString("-50",LBorder-30, BBorder+(i*deltay)+5);}
        if (i==10) { g2.drawString("-100",LBorder-30, BBorder+(i*deltay)+5); 
                     temp = BBorder-(i*deltay);}
                   
                 
      };
    }
    
    
// drawing the input output values
    
    float percentage = BBorder - temp;    
    float maximum=0;
    float fyvalue=0; 
    int temp_x = LBorder, temp_y = BBorder;
    int x,y;
    
    FontMetrics metrics = g2.getFontMetrics(); // to get the length of a string in a spezific font in pixels
    
    // General Output 
    if(getCurrentIsInput())   // Is an input pattern selected?
    {
      g2.drawString("Input Units", RBorder - 50,  BBorder + 35);
      int width = metrics.stringWidth(m_strX);
      g2.drawString(m_strX, RBorder - width,  BBorder + 48);
    
      
      g2.drawString("InputPattern " + getCurrentPattern() + " - selected", d.width / 2, d.height - 20);
      
      int xOff = LBorder;
      int yOff = BBorder;
      float deltax_f = (RBorder - LBorder -20)/ m_data.numbOfInputUnits();
      int deltax = (int)deltax_f;
      
      for(int i=0; i < m_data.numbOfInputUnits(); i++)
      { x = xOff+((i+1)*deltax);
        g2.drawLine( x, yOff+2, x, yOff-2);
        g2.drawString("" +i, x-3, yOff +20);
       
        
        if  (Math.abs(m_data.getInputData(getCurrentPattern(),i)) >= maximum)
        { maximum = Math.abs(m_data.getInputData(getCurrentPattern(),i));}
                      
      };
     

      
      for(int i=0; i < m_data.numbOfInputUnits(); i++)
      { x =  xOff+((i+1)*deltax);
        y =  (int)( BBorder - fyvalue );           
        
        g2.setPaint(red);
        if (maximum != 0) fyvalue = (m_data.getInputData(getCurrentPattern(),i)*percentage)/maximum; 
        g2.fillOval(x-2, y-2, 5, 5);
        
        g2.setPaint(green);
        g2.drawLine(temp_x, temp_y-1, x, y-2);
   
        temp_x = x;
        temp_y = y;
        
        g2.setPaint(black);
        g2.drawString("" + m_data.getInputData(getCurrentPattern(),i), x-5, y-5); 
        
      };
   }
    
    
    else             // A output pattern is selected.
    {         
      g2.drawString("Output Units", RBorder - 50,  BBorder + 35);
      int width = metrics.stringWidth(m_strX);
      g2.drawString(m_strX, RBorder - width,  BBorder + 48);
    
      g2.drawString("OutputPattern " +getCurrentPattern()+ " - selected", d.width / 2, d.height - 20);
     
      int xOff = LBorder;
      int yOff = BBorder;
      int deltax_f =(RBorder - LBorder -20)/ m_data.numbOfOutputUnits();
      int deltax = (int)deltax_f;
      
      for(int i=0; i<m_data.numbOfOutputUnits();i++)
      { x = xOff+((i+1)*deltax);
        g2.drawLine(x, yOff+2, x, yOff-2);
        g2.drawString("" +i, x-3, yOff +20);
             
        if  (Math.abs(m_data.getOutputData(getCurrentPattern(),i)) >= maximum)
        { maximum = Math.abs(m_data.getOutputData(getCurrentPattern(),i));}
      };
      

      
      for(int i=0; i < m_data.numbOfOutputUnits(); i++)
      { x =  xOff+((i+1)*deltax);
        y =  (int)( BBorder - fyvalue );
        
        g2.setPaint(red);
        if (maximum != 0) fyvalue = (m_data.getOutputData(getCurrentPattern(),i)*percentage)/maximum; 
        g2.fillOval(x-2,y-2, 5,5);
        
        g2.setPaint(green);
        g2.drawLine(temp_x, temp_y-1, x, y-2);
   
        temp_x = x;
        temp_y = y;
        
        g2.setPaint(black);
        g2.drawString("" + m_data.getOutputData(getCurrentPattern(),i), x-5, y-5); 
      
      };
  
    }
  }
}

